package dm8xx.examples;

import java.util.*;

public class Proposal
{
	public static void main(String[] args)
	{
		/*
		// Non-parameterized (raw) types
		List list = new ArrayList();
		list.add("text");
		Number Number = (Number) list.get(0); // Runtime error
		
		// Parameterized types
		List<String> strList = new ArrayList<String>();
		strList.add("text");
		Number number = strList.get(0); // Compile-time error
		*/
		
		/*
		String string = "text";
		Object object = string; // OK
		
		String[] strArray = new String[] { "text", "more text" };
		Object[] objArray = strArray; // OK
		
		List<String> strList = new ArrayList<String>();
		List<Object> objList = strList; // Compile-time error because
		objList.add(new Object()); // this should not be allowed
		*/
		
		/*
		List<String> strList = new ArrayList<String>();
		strList.add("text"); strList.add("more text");
		print1(strList); // Compile-time error
		print2(strList); // OK
		*/
		
		/*
		List<Number> numList = new ArrayList<Number>();
		numList.add(1); numList.add(3.14f);
		
		List<Float> fltList = new ArrayList<Float>();
		fltList.add(3.14f);
		
		print3(numList); // OK
		print3(fltList); // Compile-time error
		
		print4(numList); // OK
		print4(fltList); // OK
		*/
	}
	
	
	public static void print1(Collection<Object> collection) {
		for(Object object : collection) {
			System.out.println(object.toString());
		}
	}

	public static void print2(Collection<?> collection) {
		for(Object object : collection) {
			System.out.println(object.toString());
		}
	}
	
	public static void print3(Collection<Number> collection) {
		for(Number number : collection) {
			System.out.println(number.toString());
		}
	}
	
	public static <N extends Number> void print4(
			Collection<N> collection) {
		for(N number : collection) {
			System.out.println(number.toString());
		}
	}
}
